GDAL-VECTOR-EDIT(1)

NAME
gdal-vector-edit - Edit metadata of a vector dataset

Added in version 3.11.

SYNOPSIS

            Usage: gdal vector edit [OPTIONS] <INPUT> <OUTPUT>

            Edit metadata of a vector dataset.

            Positional arguments:
              -i, --input <INPUT>                                  Input vector datasets [required] [not available in pipelines]
              -o, --output <OUTPUT>                                Output vector dataset [required] [not available in pipelines]

            Common Options:
              -h, --help                                           Display help message and exit
              --json-usage                                         Display usage as JSON document and exit
              --config <KEY>=<VALUE>                               Configuration option [may be repeated]
              -q, --quiet                                          Quiet mode (no progress bar or warning message) [not available in pipelines]

            Options:
              -l, --layer, --input-layer <INPUT-LAYER>             Input layer name(s) [may be repeated] [not available in pipelines]
              -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed) [not available in pipelines]
              --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated] [not available in pipelines]
              --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated] [not available in pipelines]
              --overwrite                                          Whether overwriting existing output dataset is allowed [not available in pipelines]
              --update                                             Whether to open existing dataset in update mode [not available in pipelines]
              --overwrite-layer                                    Whether overwriting existing output layer is allowed [not available in pipelines]
              --append                                             Whether appending to existing layer is allowed [not available in pipelines]
                                                                   Mutually exclusive with --upsert
              --output-layer <OUTPUT-LAYER>                        Output layer name
              --skip-errors                                        Skip errors when writing features [not available in pipelines]
              --active-layer <ACTIVE-LAYER>                        Set active layer (if not specified, all)
              --geometry-type <GEOMETRY-TYPE>                      Layer geometry type
              --crs <CRS>                                          Override CRS (without reprojection)
              --metadata <KEY>=<VALUE>                             Add/update dataset metadata item [may be repeated]
              --unset-metadata <KEY>                               Remove dataset metadata item [may be repeated]
              --layer-metadata <KEY>=<VALUE>                       Add/update layer metadata item [may be repeated]
              --unset-layer-metadata <KEY>                         Remove layer metadata item [may be repeated]
              --unset-fid                                          Unset the identifier of each feature and the FID column name

            Advanced Options:
              --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated] [not available in pipelines]
              --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated] [not available in pipelines]
              --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated] [not available in pipelines]
              --upsert                                             Upsert features (implies 'append') [not available in pipelines]
                                                                   Mutually exclusive with --append

DESCRIPTION

gdal vector edit can be used to edit metadata of a vector dataset: its CRS, the layer geometry type, dataset and layer metadata.

edit can also be used as a step of gdal vector pipeline.

Features are not modified.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a vector dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

PROGRAM-SPECIFIC OPTIONS

    --crs <CRS>
        Override CRS, without reprojecting.

        The coordinate reference systems that can be passed are anything supported by the OGRSpatialReference::SetFromUserInput() call, which includes EPSG Projected, Geographic or Compound CRS (i.e. EPSG:4296), a well known text (WKT) CRS definition, PROJ.4 declarations, or the name of a .prj file containing a WKT CRS definition.

        null or none can be specified to unset an existing CRS.

    --geometry-type <GEOMETRY-TYPE>
        Change the layer geometry type to be one of GEOMETRY, POINT, LINESTRING, POLYGON, MULTIPOINT, MULTILINESTRING, MULTIPOLYGON, GEOMETRYCOLLECTION, CURVE, CIRCULARSTRING, COMPOUNDCURVE, SURFACE, CURVEPOLYGON, MULTICURVE, MULTISURFACE, POLYHEDRALSURFACE or TIN. Z, M or ZM suffixes can be appended to the above values to indicate the dimensionality. Note that feature geometries themselves are not modified. Thus this option can be used to fix an inappropriate geometry type at the layer level.

    --layer-metadata <KEY>=<VALUE>
        Add/update metadata item, at the layer level.

    --metadata <KEY>=<VALUE>
        Add/update metadata item, at the dataset level.

    --unset-fid
        Added in version 3.12.

        Can be specified to prevent the name of the source FID column and source feature IDs from being reused for the target layer. This option can for example be useful if selecting source features with a ORDER BY clause.

    --unset-metadata <KEY>
        Remove metadata item, at the dataset level.

    --unset-layer-metadata <KEY>
        Remove metadata item, at the layer level.

STANDARD OPTIONS

    --active-layer <ACTIVE-LAYER>
        Set the active layer. When it is specified, only the layer specified by its name will be subject to the processing. Other layers will be not modified. If this option is not specified, all layers will be subject to the processing.

    --append
        Whether appending features to existing layer(s) is allowed. This also creates the output dataset if it does not exist yet.

    --co, --creation-option <NAME>=<VALUE>
        Many formats have one or more optional dataset creation options that can be used to control particulars about the file created. For instance, the GeoPackage driver supports creation options to control the version.

        May be repeated.

        The dataset creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

        Note that dataset creation options are different from layer creation options.

    --if, --input-format <format>
        Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

        May be repeated.

    --input-layer <INPUT-LAYER>
        Specifies the name of one or more layers to process. By default, all layers will be processed. To read and write all layers but only process a subset, use --active-layer.

    --lco, --layer-creation-option <NAME>=<VALUE>
        Many formats have one or more optional layer creation options that can be used to control particulars about the layer created. For instance, the GeoPackage driver supports layer creation options to control the feature identifier or geometry column name, setting the identifier or description, etc.

        May be repeated.

        The layer creation options available vary by format driver, and some simple formats have no layer creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

        Note that layer creation options are different from dataset creation options.

    --oo, --open-option <NAME>=<VALUE>
        Dataset open option (format specific).

        May be repeated.

    -f, --of, --format, --output-format <OUTPUT-FORMAT>
        Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

    --output-layer <NAME>
        Specifies the name of the layer to which features will be written. If not specified, output layer names will be the same as input layer names.

    --output-open-option, --output-oo <NAME>=<VALUE>
        Added in version 3.12.

        Dataset open option for output dataset (format specific).

        May be repeated.

    --overwrite
        Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

    --overwrite-layer
        Whether overwriting the existing output vector layer is allowed.

    --skip-errors
        Added in version 3.12.

        Whether failures to write feature(s) should be ignored. Note that this option sets the size of the transaction unit to one feature at a time, which may cause severe slowdown when inserting into databases.

    --update
        Whether to open an existing output dataset in update mode.

    --upsert
        Added in version 3.12.

        Variant of --append where the OGRLayer::UpsertFeature() operation is used to insert or update features instead of appending with OGRLayer::CreateFeature().

        This is currently implemented only in a few drivers: GPKG -- GeoPackage vector, Elasticsearch: Geographically Encoded Objects for Elasticsearch and MongoDBv3 (drivers that implement upsert expose the GDAL_DCAP_UPSERT capability).

        The upsert operation uses the FID of the input feature, when it is set (and the FID column name is not the empty string), as the key to update existing features. It is crucial to make sure that the FID in the source and target layers are consistent.

        For the GPKG driver, it is also possible to upsert features whose FID is unset or non-significant (the --unset-fid option of gdal vector edit can be used to ignore the FID from the source feature), when there is a UNIQUE column that is not the integer primary key.

RETURN STATUS CODE

The program returns status code 0 in case of success, and non-zero in case of error (non-blocking errors emitted as warnings are considered as a successful execution).

EXAMPLES

  Example 1: Change the CRS of a GeoPackage file (without reprojecting it) and its geometry type

            $ gdal vector edit --crs=EPSG:4326 --geometry-type=POLYGONZM in.gpkg out.gpkg --overwrite

  Example 2: Apply a CRS to a Shapefile

If a Shapefile is missing its associated .prj file, it can be created as follows:

            $ gdal vector edit --crs=EPSG:3857 in.shp out.shp

AUTHOR
Even Rouault <even.rouault@spatialys.com>

COPYRIGHT
1998-2026